#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

header "CA" "Recreate" "@TR<<Recreate Certificate Authority>>"

BASEDIR="/packetprotector"
DH_RUNNING=`ps | grep "openssl dhparam" | grep -v grep`

if [ $FORM_initialize ] ; then
	echo '<pre>'
	cd /etc/easy-rsa/keys
	if [ -n $DH_RUNNING ] ; then
		echo 'Diffie Hellman parameters are currently being generated.'
		echo ''
		echo '$DH_RUNNING'
		echo ''
		echo 'Please check back in 15-30 minutes.'
		echo '' 
	else
		# Backup keys and certs
		cd /etc/easy-rsa
		. ./vars
		d=$KEY_DIR
		mkdir `pwd`/bkup-keys 2> /dev/null
		cp -dpf $d/* `pwd`/bkup-keys/
		cp -pf $d/.* `pwd`/bkup-keys/
		cp -pf /etc/mini_httpd/server.pem /etc/mini_httpd/bkup-server.pem
		# End backup
		# Start recreating
		. ./vars > /dev/null
		./clean-all
		echo $(($RANDOM % 89 + 10)) > keys/serial
		./build-ca-batch
		./build-key-server-batch server
		./build-key-radius-batch radius
		. ./vars > /dev/null
		cp openssl-revoked.cnf openssl-client.cnf
		./build-key-pass-batch examplerevokedcert
		rm openssl-client.cnf
		./revoke-full examplerevokedcert
		echo 'Generating Diffie Hellman parameters.'
		echo ''
		echo 'GET COMFORTABLE, THIS MAY TAKE 15-30 MINUTES!'
		echo ''
		. ./vars > /dev/null
		./build-dh
		cat server.crt server.key > /etc/mini_httpd/server.pem
		echo 'Completed creating CA and Server certificates.'
		echo 'To complete certificate creation, please visit the VPN tab to recreate the roots certificate.'
		echo ''
	fi
	echo '</pre>'
fi		

cd /etc/easy-rsa/keys
if [ -s "dh1024.pem" ] ; then
	echo '<br />******************WARNING**********************<br /><br />'
	echo 'The local CA is already initialized.<br /><br />'
elif [ -n $DH_RUNNING ] ; then
        echo 'Diffie Hellman parameters are currently being generated.<br />'
        echo '<pre>$DH_RUNNING</pre><br />'
        echo 'Please check back in 15-30 minutes.<br />'
else
	echo 'CA is not initialized.<br /><br />'
	echo '<form enctype="multipart/form-data" method="post">'
	echo 'Click <input type="submit" name="initialize" value="initialize"> to enable the local certificate authority.<br /><br />'
	echo 'WARNING- it may take 15-30 minutes to generate the Diffie Hellman parameters!<br /><br />'
fi

echo '******************WARNING**********************<br /><br />'
echo 'Click the button ONLY if you want to recreate the local CA<br /><br />'
echo '<form enctype="multipart/form-data" method="post">'
echo 'Click <input type="submit" name="initialize" value="initialize"> to re-create the local certificate authority.<br /><br />'
echo 'WARNING- it may take 15-30 minutes to generate the Diffie Hellman parameters!<br /><br />'

footer ?>
<!--
##WEBIF:name:CA:2:Recreate
-->
